--Aeries.NET Effective Permissions Query -- Aeries Software - Jared Kuszewski 2015-05-06
--revised 02/13/2018

declare @TeacherSCH smallint
declare @YR smallint
--##########################################################
--Teacher permissions are school specific   SET THE @TeacherSCH school number in the next line
set @TeacherSCH = null
--Pick 0 for current Years or (1 or 2) for evaluating 1 or 2 years prior. 2 is all years 2 or more years old in the past
set @YR = 0
--##########################################################

if (select @TeacherSCH) is null goto TeachSCH_unspecified

;WITH UGA_recursed ([UID], gid, GroupLevel, FromGroup)
AS (SELECT [UID], GID, 1 as GroupLevel, null as FromGroup FROM dbo.UGA WHERE DEL = 0
UNION ALL
SELECT UGA_recursed.[UID], UGA.GID, GroupLevel + 1, uga.uid FromGroup
FROM dbo.UGA INNER JOIN UGA_recursed ON UGA_recursed.gid = UGA.[UID] WHERE UGA.del = 0)
, SchoolsInUSR (un, SchPerms)
as
(select un, case 
when uty like '%admin' then 'AdminHasAll'
when uty like '%user' then 
isnull(
stuff(
(select ',' + cast(sch as varchar(4)) from usr where nm = ugn.un and del = 0 order by sch for xml path(''))
,1,1,'') 
,'')  
when uty like '%teacher' then
isnull(
stuff(
(select ',' + cast(sc as varchar(4)) from tch where (id = ugn.sid or id2 = ugn.sid or id3 = ugn.sid) and del = 0 group by sc order by sc for xml path(''))
,1,1,'') 
,'')  
else '' end SchPerms
from ugn
where ty = 1 and st = 0 and del = 0 and (xd > CURRENT_TIMESTAMP or xd is null))


select UN, FN, LN, EM, UTY, TC, FC, 
case when max(RD) = 2 then 'Denied' when max(RD) = 1 then 'Read' else '' end as [READ],
case when max(UP) = 2 then 'Denied' when max(UP) = 1 then 'Update' else '' end as [UPDATE],
case when max(INS) = 2 then 'Denied' when max(INS) = 1 then 'Insert' else '' end as [INSERT],
case when max(DL) = 2 then 'Denied' when max(DL) = 1 then 'Delete' else '' end as [DELETE],
case when max(MU) = 2 then 'Denied' when max(MU) = 1 then 'MassUpd' else '' end as [MassUpd],
case when max(AD) = 2 then 'Denied' when max(AD) = 1 then 'Administer' else '' end as [Adminst]
, SchPerms

from

(select UGN.[UID], UGN.UN, UGN.FN, UGN.LN, UGN.EM, UGN.UTY, uga_recursed.GID as GID, gugn.un as GNAME, UGP.TC, UGP.FC, UGP.RD, UGP.UP, UGP.INS, UGP.DL, UGP.MU, UGP.AD, SchPerms
from ugn inner join uga_recursed on uga_recursed.[UID] = ugn.[UID]
inner join ugn as gugn on uga_recursed.gid = gugn .[UID]
inner join ugp on uga_recursed.gid = ugp.[UID]
left join SchoolsInUSR on SchoolsInUSR.un = ugn.un
where ugn.del = 0 and gugn.del = 0 and gugn.st = 0 and ugp.del = 0 and ugp.yr = @YR

union all

--Explicit Permissions given directly to a user
select UGN.[UID], UGN.UN, UGN.FN, UGN.LN, UGN.EM, UGN.UTY, 0 as GID, cast('SELF' as varchar (255)) as GNAME, UGP.TC, UGP.FC, UGP.RD, UGP.UP, UGP.INS, UGP.DL, UGP.MU, UGP.AD, SchPerms
from ugn left join ugp on ugn.[UID] = ugp.[UID]
left join SchoolsInUSR on SchoolsInUSR.un = ugn.un
where ugn.del = 0 and ugn.ty = 1 and ( ugp.del = 0 or UGP.DEL is null) and ugp.yr = @YR

union all 

--Teacher Permissions (portal groups are not capable of inheriting)
select UGN.[UID], UGN.UN, UGN.FN, UGN.LN, UGN.EM, UGN.UTY, (select min([UID]) from ugn where un = 'Teachers' and ty = 2 and del = 0) as GID, cast('Teachers' as varchar (255)) as GNAME, UGP.TC, UGP.FC, UGP.RD, UGP.UP, UGP.INS, UGP.DL, UGP.MU, UGP.AD, SchPerms
from ugn cross join ugp
left join SchoolsInUSR on SchoolsInUSR.un = ugn.un
where ugn.del = 0 and ugn.ty = 1 and uty like '%Teacher' and ( ugp.del = 0 or UGP.DEL is null) and ugp.[UID] = (select top 1 [UID] from ugn where un = 'Teachers' and del = 0 order by uid) and ugp.sc = @TeacherSCH and ugp.yr = @YR

union all 

--Substitute Teacher Permissions (portal groups are not capable of inheriting)
select UGN.[UID], UGN.UN, UGN.FN, UGN.LN, UGN.EM, UGN.UTY, (select min([UID]) from ugn where un = 'Substitute Teachers' and ty = 2 and del = 0) as GID, cast('Substitute Teachers' as varchar (255)) as GNAME, UGP.TC, UGP.FC, UGP.RD, UGP.UP, UGP.INS, UGP.DL, UGP.MU, UGP.AD, SchPerms
from ugn cross join ugp
left join SchoolsInUSR on SchoolsInUSR.un = ugn.un
where ugn.del = 0 and ugn.ty = 1 and uty like '%Teachersub' and ( ugp.del = 0 or UGP.DEL is null) and ugp.[UID] = (select top 1 [UID] from ugn where un = 'Substitute Teachers' and del = 0 order by uid) and ugp.sc = @TeacherSCH and ugp.yr = @YR

) as AllPermissions

--un remark and use option on next line to lookup just one user
--where un = 'TheirUserName'

group by UN, FN, LN, EM, UTY, TC, FC, SchPerms
order by UN, FN, LN, EM, UTY, TC, FC, SchPerms

goto ending

TeachSCH_unspecified:
print 'TeacherSCH not specified - Unable to evaluate teacher permissions without specifying a school at the top of script'

Ending:
