--SQL User Role Memberships and the Inheritance Thereof
--Aeries Software Inc - by Jared Kuszewski
;WITH Role_Recursive (MemberID, RoleID, Hierarchy, FromRole) as
(select member_principal_id, role_principal_id, 1 as Hierarchy, null as FromRole from sys.database_role_members
union all 
select MemberID, role_principal_id, Hierarchy + 1, Member_principal_id FromRole
from Role_Recursive inner join sys.database_role_members on RoleID = Member_principal_id)
--select * from Role_Recursive

select * from 
(SELECT princ.[name] as [UserName]
      ,Role_Recursive.Hierarchy
	  ,(select distinct name from sys.database_principals R where r.principal_id = Role_Recursive.RoleID) as RoleName
	  ,(select distinct name from sys.database_principals R where r.principal_id = Role_Recursive.FromRole) as FromRole

FROM  sys.database_principals princ LEFT JOIN 
      Role_Recursive on Role_Recursive.MemberID = princ.principal_id
WHERE princ.type <> 'R'
) Perms

--where USERNAME = 'SomoneSpecific'

order by UserName, Hierarchy
